/////////////////////
//www.hellofpga.com//
/////////////////////
`timescale 1ns / 1ps
module PWM_TEST(
    input clk,//ʱź125Mhz
    input rst,//λź ģ⸴λ
    output led
);

reg  [16:0]  time_count=17'd0;
 
//0-50000ļ1ms
always @(posedge clk or posedge rst) begin
    if(rst)begin
        time_count<=17'd0;
    end
    else if(time_count == 17'd125_000)
        time_count <= 17'd0;
    else 
        time_count <= time_count + 1'b1;
end

reg  [15:0]  pwm_perid=16'd0;
reg  mode=0;//modeΪ0modeΪ1ΪԼ
always @(posedge clk or posedge rst) begin
    if(rst)begin
        pwm_perid<=16'd0;
    end
    else if(time_count== 17'd125_000)begin
        if(mode==1'b0)begin
            if(pwm_perid<16'd50_000) pwm_perid<=pwm_perid+50;
            else mode<=1'b1;
         end
        else if(mode==1'b1)begin
            if(pwm_perid>16'd0) pwm_perid<=pwm_perid-50;
            else mode<=1'b0;
         end
    end
end
 
assign led=(time_count <pwm_perid)?1:0;
 
endmodule
